require 'vikiwikisys'

module VikiWiki
	class PluginHook
		def initialize(file, conf, cgi, methodcheck = true)
			begin
				if methodcheck && cgi.request_method != "POST" then
					raise "unsupported method `#{cgi.request_method}'."
				end

				sys = VikiWiki::Sys.new(file, conf, cgi)
				sys.setup

				plugin_hook_names = sys['PLUGIN_HOOK_NAMES']
				pi_name = sys.cgi.params['pi_name'][0]
				if !(Array === plugin_hook_names) || !plugin_hook_names.include?(pi_name) then
					raise "The specified plugin #{pi_name} can not be used."
				end

				if !sys.page.static then
					raise "The setting is not for the Static HTMLs."
				end

				sys.plugin_onpost

				uri = sys.page.static.uri
				sys.print sys.location(uri)
			rescue
				($VIKIWIKIOUT || $>).print error_response(conf)
			end
		end

		private

		def error_response(conf)
			btrace = conf["DEBUG"] ? ::CGI::escapeHTML($@.to_a.join("\n")) : ""

			"Content-type: text/html\n\n" + \
			::CGI.element('html') do |recv|
				recv << ::CGI.element('head') do
					::CGI.element('title') { "Update Error for VikiWiki" }
				end
				recv << ::CGI.element('body') do |recv|
					recv << ::CGI.element('h1') { "Update Error" }
					recv << ::CGI.element('p') { ::CGI::escapeHTML($!.to_s) }
					recv << %[<!--\n#{btrace}\n-->\n]
					recv << ::CGI.element('p') do |recv|
						recv << "Back to the previous page and try again. "
						recv << "Or, call your system administrator."
					end
				end
			end + "\n"
		end
	end
end
