# ==========================================================
# pre-setup.rb -- preload script of "setup.rb setup".
#
# Copyright (C) 2005 Z80-OOLONG. (NAKATSUKA, Yukitaka)
# ==========================================================

require "fileutils"
require "find"

# ----------------------------------------------------------

rubyprog = get_config("rubyprog")

kcode = case get_config("encoding")
        when /.*euc[-_]?jp$/i;    "e"
        when /.*shift[-_]?jis$/i; "s"
        else;                     "u"
        end

# ----------------------------------------------------------

Dir.chdir("../..") do
  # Fix vikiwiki/setup.rb

  open("./setup-tmp.cgi", "w") do |fout|
    File.foreach("./setup.cgi") do |line|
      line.gsub!(/^(DEFAULT_CONF\['TOPPAGE'\]\s*=.*)$/,
                 "\\1\nDEFAULT_CONF['$VIKIWIKIBASE'] = '#{Dir::pwd}'\n")
      fout.print(line)
    end
  end

  open("|#{rubyprog} -Ku ./setup-tmp.cgi", "r+") do |io|
    io.print "Administrator\n"
    io.print "admin\n"
    io.print "admin@example.com\n"
    io.print "#{Dir::pwd}/webrick/data/vikiwiki/master\n"
    io.print "/\n\n\n"
    io.print "/vikiwiki.cgi\n"
    io.print "#{Dir::pwd}/webrick/data/vikiwiki/master/vikiwiki.cgi\n\n\n\n"
    io.print "#{Dir::pwd}/webrick/data/vikiwiki/master/tmp\n"
    io.print "2\n2\n\n2\n"
    io.print "#{Dir::pwd}/webrick/data/vikiwiki/master/static\n"
    io.print "/static\n"
    io.print "admin\nadmin\n"
    io.print "y\n"
    io.close_write
    while line = io.gets do
      print line
    end
  end
  FileUtils.cp("./parameter.txt",
    "./webrick/data/vikiwiki/master/text/ParameterEdit.VikiWikiStyle.txt")
  FileUtils.rm_f("./setup-tmp.cgi")
end

if (kcode != "u") then
  Find.find("./vikiwiki") do |f|
    if /.*(\.txt|\.css)$/ =~ f then
      print "convert encoding ... "
      system("#{rubyprog} ../../tool/unkf.rb -U#{kcode} #{f}")
    end
  end
end

FileUtils.rm_f("./vikiwiki/master/vikiwiki.cgi")

# ==========================================================
