# ==========================================================
# pre-config.rb -- preload script of "setup.rb config".
#
# Copyright (C) 2005 Z80-OOLONG. (NAKATSUKA, Yukitaka)
# ==========================================================

require "fileutils"

rbdir           = get_config("rbdir")
datadir         = get_config("datadir")
rubypath        = get_config("rubypath")
libtidy_so_path = get_config("libtidypath")

encoding, kcode = \
  case get_config("encoding")
  when /.*euc[-_]?jp$/;	   ["euc-jp", "e"]
  when /.*shift[-_]?jis$/; ["Shift_JIS", "s"]
  else;			   ["utf-8", "n"]
  end

FileUtils.rm_rf("./vikiwiki")

open("./config.rb", "w") do |cf|
  cf.print(<<-EOCODE)
# Environment Setting
$KCODE           = "#{kcode}"
$VIKIWIKIENCODE  = "#{encoding}"
$VIKIWIKIDIR     = "#{rbdir}/vikiwiki"
$VIKIWIKIMASTER  = "#{datadir}/vikiwiki/master"
$VIKIWIKITMP     = "/tmp"
$LIBTIDY_SO_PATH = "#{libtidy_so_path}"
$VIKIWIKIRUBY    = "#{rubypath}"
$VIKIWIKIOUT     = $>
  EOCODE
end

# ==========================================================
